/*
proc_ll.s - Low level process management and thread scheduling functions

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

  .global proc_init_thrd_
  .type proc_init_thrd_, @function
proc_init_thrd_:

  // Pop current thread pointer
  popl %edi

  // Load this thread into current thread pointer
  popl (%edi)

  // Update %cr3
  popl %eax
  movl %cr3, %ecx
  subl %eax, %ecx
  jecxz 1f // Skip if identical VAS
  movl %eax, %cr3

1:
  jmp isr_return_asm_
