/*
c++runtime.cpp - C++ runtime functions

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#include <fiku/panic.h>

extern "C" int
__cxa_atexit ()
{

  // Ignore, TODO: is calling destructor really need?
  return 0;
}

extern "C" __attribute__ ((noreturn)) void
__cxa_pure_virtual ()
{
  panic ("error: call to pure virtual function");
}
