/*
crti.s - Global constructor and destructor related symbols

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

  .section .init
  .global _init
  .type _init, @function
_init:
  pushl %ebp
  movl %esp, %ebp
  .size _init, . - _init

  .section .fini
  .global _fini
  .type _fini, @function
_fini:
  pushl %ebp
  movl %esp, %ebp
  .size _fini, . - _fini
