/*
errno.h - C standard errno header

This file is a part of Fiku.
Copyright (C) 2021 Akib Azmain Turja

Fiku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Fiku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Authors: Akib Azmain Turja
*/

#pragma once

#ifdef __cplusplus
extern "C"
{
#endif

extern int error_number_;

#define errno error_number_

#define ENONE 0
#define ERANGE 1
#define EDOM 2
#define EILSEQ 3
#define EAGAIN 4
#define EUNAVAILABLE 5
#define EBUSY 6

#ifdef __cplusplus
}
#endif
